HDU 1072 Nightmare

题目描述

Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius' start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can't get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can't use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.

输入

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius' start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius' target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.

输出

For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.

样例输入

3
3 3
2 1 1
1 1 0
1 1 3
4 8
2 1 1 0 1 1 1 0
1 0 4 1 1 0 4 1
1 0 0 0 0 0 0 1
1 1 1 4 1 1 1 3
5 8
1 2 1 1 1 1 1 4 
1 0 0 0 1 0 0 1 
1 4 1 0 1 1 0 1 
1 0 0 0 0 3 0 1 
1 1 4 1 1 1 1 1

样例输出

4
-1

13

翻译:在走迷宫,但是这个人身上帮里一个定时炸弹,定时炸弹只有6秒,每走一步都会消耗一秒的时间,天无绝人之路,迷宫里有可以重置炸弹的点,走到这个点的时候,定时炸弹就会重置为6秒,问你走出命宫最短步数,不能走出,输出-1.

思路

一看求最短路,首先想到广搜,但是这个题由于有重置炸弹的点,所以要用记忆化搜索,注意点就是:

1.走过的路不要全部标记为不能走的,要判断上次走到这的点剩余的时间是不是比这次的小,如果小,就走,并且替代掉

2.走过的重置点,就不要再走了,因为你在这重置过之后都没出去,再回来也没用

代码:

#include<iostream>

#include<queue> #include<cstdio> #include<cstring> using namespace std; struct b {   int x;   int y;   int t;   int step; }dian,Dian; queue<b>q; int Map[10][10]; int book[10][10]; int f,m,n; int sx,sy,ex,ey,st; void BFS(int sx,int sy) {   int next[4][2]={{0,1},{1,0},{0,-1},{-1,0}};   int k;   while(!q.empty())     q.pop();   Dian.x=sx;   Dian.y=sy;   Dian.t=6;   Dian.step=0;   q.push(Dian);   while(!q.empty())   {      Dian=q.front();      q.pop();      for(k=0;k<4;k++)      {        dian.x=Dian.x+next[k][0];        dian.y=Dian.y+next[k][1];        dian.t=Dian.t-1;        dian.step=Dian.step+1;        if(dian.x>=n||dian.x<0||dian.y>=m||dian.y<0)continue;        if(dian.x==ex&&dian.y==ey&&dian.t>0)        {           f=1;          st=dian.step;          return ;        }        if(Map[dian.x][dian.y]==4&&dian.t>0)        {          dian.t=6;          q.push(dian);          Map[dian.x][dian.y]=0;               }        if(Map[dian.x][dian.y]==1&&dian.t>0&&dian.t>book[dian.x][dian.y])        {             q.push(dian);             book[dian.x][dian.y]=dian.t;                }      }   } } int main() {   int t,i,j;   cin>>t;   while(t--)   {     cin>>n>>m;     for(i=0;i<n;i++)     {       for(j=0;j<m;j++)       {         cin>>Map[i][j];         book[i][j]=0;         if(Map[i][j]==2)         {           sx=i;           sy=j;         }         if(Map[i][j]==3)         {           ex=i;           ey=j;         }       }     }     f=0;     BFS(sx,sy);     if(!f)       cout<<"-1"<<endl;     if(f)       cout<<st<<endl;   } }

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值